/*--------------------------------------------------------------------------*/
/*                                                                          */
/*      Filename: dasinst.cmd                                               */
/*                                                                          */
/*      Project:  DAS                                                       */
/*                                                                          */
/*      Description: DAS installation program                               */
/*                                                                          */
/*      Author: Jrg Knig                                                  */
/*                                                                          */
/*      History:                                                            */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/*      (C) Copyright EMASS, Inc. 1996                                      */
/*                                                                          */
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/* Adjust next 2 definitions for every new release...                       */
/*--------------------------------------------------------------------------*/
VERSION = "3.01 "
DASFILE = "DAS*.ZIP"

ACIFILE1 = "ACI*_1.ZIP"
ACIFILE2 = "ACI*_2.ZIP"
ACIDISKS  = 2

BACKUP_DIR = "C:\DAS\DAS_SAVE"
BACKUP_BIN = "C:\DAS\DAS_SAVE\BIN"
BACKUP_ETC = "C:\DAS\DAS_SAVE\ETC"
BACKUP_TOOLS = "C:\DAS\DAS_SAVE\TOOLS"
BACKUP_ACI = "C:\DAS\DAS_SAVE\ACI"

DAS_DIR = "C:\DAS"
DAS_BIN = "C:\DAS\BIN"
DAS_ETC = "C:\DAS\ETC"
DAS_TOOLS = "C:\DAS\TOOLS"
DAS_TOOLS_DBM = "C:\DAS\TOOLS\dbm"
DAS_TOOLS_DB2 = "C:\DAS\TOOLS\db2"
DAS_ACI = "C:\DAS\ACI"


/*--------------------------------------------------------------------------*/
/* frames to convert config file 1.3x to 3.x                                */
/*--------------------------------------------------------------------------*/
frame = "##############################################################################"
frame1 = "#                                                                            #"

CONFIGDAS_NEW = "C:\DAS\ETC\CONFIG.NEW"
CONFIGDAS_SMP = "C:\DAS\ETC\CONFIG.SMP"
CONFIGDAS_OLD = "C:\DAS\ETC\CONFIG.OLD"

CONFIG_SYS = "C:\CONFIG.SYS"
CONFIG_DAS = "C:\CONFIG.DAS"
CONFIG_NEW = "C:\CONFIG.NEW"

STARTUP_SAMPLE = "C:\das\tools\startup.smp"



/*--------------------------------------------------------------------------*/
/*  Environment variables for and DAS                                       */
/*--------------------------------------------------------------------------*/
DASPATHLINE1 = "SET DAS_SERVER=AMU"
DASPATHLINE2 = "SET DAS_CLIENT=AMUCLIENT"



/*--------------------------------------------------------------------------*/
/*  Damit 'n paar gute Funktionalitten zur Verfgung stehen ...            */
/*--------------------------------------------------------------------------*/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs


/*--------------------------------------------------------------------------*/
/*  dann noch n paar Tne                                                   */
/*--------------------------------------------------------------------------*/
viertel = 400
achtel  = viertel / 2
sechzehntel = achtel / 2
achtelpkt = achtel + sechzehntel
note.1 = 262    /* middle C */
note.2 = 294    /*    D     */
note.3 = 330    /*    E     */
note.4 = 349    /*    F     */
note.5 = 392    /*    G     */
note.6 = 440    /*    A     */
note.7 = 494    /*    B     */
note.8 = 524    /*    C     */



/****************************************************************************\
  Hier beginnt das Hauptmenue. Dreimal kann eingeben werden, dann ist Schlu
\****************************************************************************/
INST_UTL_DATE = stream('a:\dasinst.cmd', 'c', 'query datetime')

'@echo off'
DO 3
  call SysCls
  say ""
  say "Ŀ"
  say "      GRAU Storage Systems, AMU-Service, "INST_UTL_DATE"           "
  say "                                                                      "
  say "              I N S T A L L A T I O N     U T I L I T Y               "
  say "                  DAS  -  V E R S I O N  " VERSION"                        "
  say "                                                                      "
  say " 1 = New Installation of DAS Server Software                          "
  say "     (Installation without backup of an older Version)                "
  say "                                                                      "
  say " 2 = DAS Software Update from DAS 3.x to DAS" VERSION"                     "
  say "                                                                      "
  say " 3 = DAS Software Update from DAS 1.30x to DAS" VERSION"                    "
  say "                                                                      "
  say " 4 = DAS Software Update from DAS 1.20x to DAS" VERSION"                   "
  say "                                                                      "
  say " 5 = Deinstallation of the last update                                "
  say "                                                                      "
  say " 6 = Deinstallation of complete DAS                                   "
  say "                                                                      "
  say " 7 = End                                                              "
  say "                                                                      "
  say "                                                                      "
  say " Select an Option:                                                    "
  say ""
  cpos = SysCurPos(22,24)
  Option = translate(SysGetKey('NOECHO'))
  cls
  say ""
  say ""
  if Option = "1" then
  do
    call DasInstall
    call config_update
    call DUALDAS
    call aci_install
    call GoodEnd
  end

  if Option = "2" then
  do
    call Backup
    call DasUpdate
    call config_update
    call DUALDAS
    call aci_install
    call GoodEnd
  end

  if Option = "3" then
  do
    call Backup
    call DasUpdate
    call config_update
    call convert_to_config30
    call DUALDAS
    call aci_install
    call GoodEnd
  end

  if Option = "4" then
  do
    call Backup
    call DasUpdate
    call convert_config
    call convert_to_config30
    call DUALDAS
    call aci_install
    call config_update
    call GoodEnd
  end

  if Option = "5" then
  do
    call Deinst_of_Update
  end

  if Option = "6" then
  do
    call Deinst_of_DAS
  end

  if Option = "7" then
  do
    cls
    EXIT
  end
end
EXIT


/************************************+***************************************/
/*                           Function BACKUP                                */
/************************************+***************************************/
Backup:
say "INFO: Backup - directory will be created..."
newdir = directory( "C:\" )
newdir = "C:\"
rc  = SysMkDir(BACKUP_DIR)
rc1 = SysMKDir(BACKUP_ETC)
rc2 = SysMKDir(BACKUP_TOOLS)
rc3 = SysMKDir(BACKUP_BIN)

if ( ( (rc = 0)|(rc = 5) ) & ( (rc1 = 0)|(rc1 = 5) ) & ( (rc2 = 0)|(rc2 = 5) ) & ( (rc3 = 0)|(rc3 = 5) ) ) then
 do
   say "INFO: DAS backup directory successfully created."
 end
else
 do
   say "ERROR: Unable to create backup directory for existing DAS installation."
   SIGNAL ENDE
 end
 

newdir = directory( "C:/das" )
if newdir = "C:\das" then
do
  say "INFO: Saving DAS-directory..."
  copy "*.*" BACKUP_DIR 
  xcopy ".\bin" BACKUP_BIN "/s"
  xcopy ".\etc" BACKUP_ETC "/s"
  xcopy ".\tools" BACKUP_TOOLS "/s"
  del "*.zip"
  say ""
end
else
do
  say ""
  say "ERROR: Unable to change to DAS directory."
  say ""
  SIGNAL ENDE
end
say "INFO: DAS directory saved."
say ""
return

/************************************+***************************************/
/*                           Function CONFIG_UPDATE                         */
/************************************+***************************************/
config_update:
say "INFO: Saving the current CONFIG.SYS file..."
copy  CONFIG_SYS CONFIG_DAS
if rc > 0 then
do
  call beep note.1,250
  say ""
  say "ATTENTION: A backup of your CONFIG.SYS already exists and"
  say "           it is already write protected!"
  say ""
  say "           Do you still want to make a backup of the file"
  say "           CONFIG.SYS into the file CONFIG.DAS? (Y/N)"
  say ""

  Answer = translate(SysGetKey('ECHO'))
  if Answer = 'y' | Answer = 'Y' then
  do
    attrib "C:\CONFIG.DAS -r"
    copy  CONFIG_SYS CONFIG_DAS
    attrib "C:\CONFIG.DAS +r"
    say ""
    say "INFO: Backup of CONFIG.SYS written to CONFIG.DAS"
    say "      and set to read only."
  end
  else
  do
    say ""
    say "INFO: Backup of CONFIG.SYS not written to CONFIG.DAS!"
  end
end
else
do
  say ""
  say "INFO: Trying to protect the backup CONFIG.SYS (CONFIG.DAS)"
  say "      from being overwritten."
  attrib "C:\CONFIG.DAS +r"
end
say ""

/*--------------------------------------------------------------------------*/
/*  Ueberpruefung LIBPATH, PATH, HELP, AMUPATH, QUADRON und DAS Environment */
/*--------------------------------------------------------------------------*/
LIBPATHUPDT = 0
DASSERVERSET = 0
DASCLIENTSET = 0

i = linein(CONFIG_NEW, 1, 0)
ret = 1
do while ret = 1
  DONEALINE = 0
  aline = linein(CONFIG_SYS)

  /*------------------------------------------------------------------------*/
  /* Setzen des LIBPATH fuer DAS ACI.DLL                                    */
  /*------------------------------------------------------------------------*/
  if LIBPATHUPDT = 0 then
  do
    i = compare( 'LIBPATH', aline)
    if i >= 8 then
    do
      p = pos("C:\DAS\ADMIN;",aline)
      q = pos("C:\DAS\BIN;",aline)
      i = length( aline )
      if p = 0 then
      do
        if q = 0 then
        do
          say "INFO: LIBPATH for DAS not found."
          c = SUBSTR(aline, i, 1)
          if c = ';' then
          do
            newline = insert( "C:\DAS\BIN;", aline, i )
            say "INFO: LIBPATH for DAS added."
          end
          else
          do
            newline = insert( ";C:\DAS\BIN;", aline, i )
            say "INFO: LIBPATH for DAS added."
          end
        end
        else
        do
          newline = insert( "", aline, i )
          say "INFO: LIBPATH for DAS already exists."
        end
      end
      else
      do
        newline = SUBSTR(aline, 1, p-1)
        j = p+13
        i = length( aline )
        c = SUBSTR(aline, j, i-j+1)
        newline = insert( c, newline, p-1 )
        if q = 0 then
        do
          i = length( newline )
          aline = SUBSTR( newline, 1, i )
          c = SUBSTR(aline, i, 1)
          if c = ';' then
          do
            newline = insert( "C:\DAS\BIN;", aline, i )
          end
          else
          do
            newline = insert( ";C:\DAS\BIN;", aline, i )
          end
          say "INFO: Removed old DAS path. New LIBPATH for DAS added."
        end
        else
        do
          say "INFO: Removed old DAS path. New LIBPATH for DAS already exists."
        end
      end
      i = lineout(CONFIG_NEW, newline)
      DONEALINE = 1
      LIBPATHUPDT = 1
    end
  end

  /*------------------------------------------------------------------------*/
  /* Ueberpruefung des DAS SERVER und CLIENT PATH                           */
  /*------------------------------------------------------------------------*/
  if DONEALINE = 0 then
  do
    if DASSERVERSET = 0 then
    do
      i = compare('SET DAS_SERVER',aline)
      if i >= 15 then
      do
        DASSERVERSET = 1
        say "INFO: DAS SERVER PATH already exists."
      end
    end
    if DASCLIENTSET = 0 then
    do
      i = compare('SET DAS_CLIENT',aline)
      if i >= 15 then
      do
        DASCLIENTSET = 1
        say "INFO: DAS CLIENT PATH already exists."
      end
    end
    i = lineout(CONFIG_NEW, aline)
  end
  ret = lines(CONFIG_SYS)
end
i = lineout(CONFIG_SYS)

/*--------------------------------------------------------------------------*/
/* Setzen des DAS SERVER PATH                                               */
/*--------------------------------------------------------------------------*/
if DASSERVERSET = 0 then
do
  i = lineout(CONFIG_NEW, DASPATHLINE1)
  say "INFO: DAS SERVER PATH added."
end

/*------------------------------------------------------------------------*/
/* Setzen des DAS CLIENT PATH                                             */
/*------------------------------------------------------------------------*/
if DASCLIENTSET = 0 then
do
  i = lineout(CONFIG_NEW, DASPATHLINE2)
  say "INFO: DAS CLIENT PATH added."
end

i = lineout( CONFIG_NEW )
say ""
copy CONFIG_NEW CONFIG_SYS
if rc = 0 then
do
  del CONFIG_NEW
  say "INFO: The CONFIG.SYS was updated. Changes will be activated on reboot."
end
else
do
  say "INFO: The CONFIG.SYS cannot be updated. Changes are stored in CONFIG.NEW."
end
say ""
return


/************************************+***************************************/
/*                           Function CONVERT_CONFIG                        */
/************************************+***************************************/
convert_config:
newdir = directory( "C:/DAS/ETC" )
if newdir = "C:\DAS\ETC" then
do
  say "INFO: Checking DAS configuration file..."
  copy "CONFIG CONFIG.OLD"
  if rc = 0 then
  do
    del "CONFIG"
    say ""
    i = linein(CONFIG, 1, 0)
    ret = 1
    AS = 0
    AM = 0
    READY = 0
    say "INFO: Converting DAS 1.20x config file..."
    say ""
    do while ret = 1
      aline = linein(CONFIG.OLD)
      if READY = 0 then
      do
        p = pos("client_name ",aline)
        if p = 0 then
        do
        end
        else
        do
          READY = 1
          i = lineout(CONFIG, aline)
        end
      end
      else
      do
        p = pos("AMPEX-SMALL",aline)
        if p = 0 then
        do
          p = pos("AMPEX-MEDIUM",aline)
          if p = 0 then
          do
            i = lineout(CONFIG, aline)
          end
          else
          do
            AM = 1
            if AS = 0 then
            do
              newline = SUBSTR(aline, 1, p-1)
              i = length( newline )
              c = insert( "AMPEX       ", newline, i )
              j = p+12
              i = length( aline )
              newline = SUBSTR(aline, j, i-j+1)
              i = length( c )
              aline = insert( newline, c, i )
              i = lineout(CONFIG, aline)
            end
          end
        end
        else
        do
          AS = 1
          if AM = 0 then
          do
            newline = SUBSTR(aline, 1, p-1)
            i = length( newline )
            c = insert( "AMPEX      ", newline, i )
            j = p+11
            i = length( aline )
            newline = SUBSTR(aline, j, i-j+1)
            i = length( c )
            aline = insert( newline, c, i )
            i = lineout(CONFIG, aline)
          end
        end
      end
      ret = lines(CONFIG.OLD)
    end
    i = lineout(CONFIG)
    i = lineout(CONFIG.OLD)
  end
  else
  do
    say ""
    say "ERROR: DAS\ETC\CONFIG file not found. Conversion of CONFIG failed!"
  end
end
else
do
  say ""
  say "INFO: DAS\ETC directory not found. Conversion of CONFIG failed!"
end
say ""
return


/************************************+***************************************/
/*                           Function CONVERT_TO_CONFIG30                   */
/************************************+***************************************/
convert_to_config30:
counter = 0
newdir = directory( "C:\DAS\ETC" )
if newdir = "C:\DAS\ETC" then
do
  say "INFO: Checking DAS configuration file..."
  copy "config config.old"
  if rc = 0 then
  do

    say "INFO: Converting to DAS 3.0 config file..."
    say ""
    ret =1
    ret1 =1

    /*-------------------------------------------*/
    /* client statement comments from config.smp */
    /*-------------------------------------------*/
    say "Statement comments ..."
    
    do while ret = 1
       aline = linein(CONFIGDAS_SMP)
       i = compare('#',aline)
       if i >= 2 then
       do
          i = lineout(CONFIGDAS_NEW, aline)
       end
       i = length(aline)
       if i = 0 then
       do
          i = lineout(CONFIGDAS_NEW, aline)
          ret = 0
       end
    end
    
    ret =1
    ret1 =1
    
    /*-------------------------------------------*/
    /* client statements from old config file    */
    /*-------------------------------------------*/
    say "Client statements ..."

    
    do while ret = 1
       aline = linein(CONFIGDAS_OLD)
       i = compare('client',aline)
       if i >= 7 then
       do
          i = lineout(CONFIGDAS_NEW, aline)
          ret1 = 1
    
          do while ret1 = 1
             aline = linein(CONFIGDAS_OLD)
             i = length(aline)
             if i = 0 then
             do
               ret1 = 0
               i = lineout(CONFIGDAS_NEW, aline)
             end
             else
             do
               i = lineout(CONFIGDAS_NEW, aline)
             end
          end
    say "Client statements ... 111"

       end /* do */
       else
       do
          i = word(aline,1)
          i = compare('clean',i)
          if i = 0 then
          do
             ret = 0
          end

          i = word(aline,1)
          i = compare('#clean',i)
          if i = 0 then
          do
             ret = 0
          end
          else
          do
             i = word(aline,2)
             i = compare('clean',i)
             if i = 0 then
             do
                ret = 0
             end
          end
          counter = counter + 1
          if counter >= 20 then
          do
             ret = 0
          end
       end
    end
    
    ret =1
    ret1 =1
    
    /*-------------------------------------------*/
    /* drive to volser comments from config.smp  */
    /*-------------------------------------------*/
    say "Drive to volser comments ..."
    
    do while ret = 1
       aline = linein(CONFIGDAS_SMP)
       i = compare('# Drive',aline)
       if i >= 8 then
       do
          i = lineout(CONFIGDAS_NEW, frame)
          i = lineout(CONFIGDAS_NEW, frame1)
          i = lineout(CONFIGDAS_NEW, aline)
    
          do while ret1 = 1
             aline = linein(CONFIGDAS_SMP)
             i = length(aline)
             if i = 0 then
             do
               ret1 = 0
               ret = 0
               i = lineout(CONFIGDAS_NEW, aline)
             end
             else
             do
               i = lineout(CONFIGDAS_NEW, aline)
             end
          end
       end
    end
    
    
    ret =1
    ret1 =1
    
    /*-------------------------------------------*/
    /* drive to volser statement from config.smp */
    /*-------------------------------------------*/
    say "Drive to volser statement ..."
    
    
    do while ret = 1
       line = linein(CONFIGDAS_SMP)
       i = compare('#DriveTo',line)
       if i >= 9 then
       do
          i = lineout(CONFIGDAS_NEW, line)
          line = linein(CONFIGDAS_SMP)
          i = lineout(CONFIGDAS_NEW, line)
          line = linein(CONFIGDAS_SMP)
          i = lineout(CONFIGDAS_NEW, line)
          ret = 0
       end
    end
    
    
    ret =1
    ret1 =1
    
    /*-------------------------------------------*/
    /* server comments from config.smp           */
    /*-------------------------------------------*/
    say "Server comments ..."
    
    do while ret = 1
       aline = linein(CONFIGDAS_SMP)
       i = compare('# Server',aline)
       if i >= 9 then
       do
          i = lineout(CONFIGDAS_NEW, frame)
          i = lineout(CONFIGDAS_NEW, frame1)
          i = lineout(CONFIGDAS_NEW, aline)
    
          do while ret1 = 1
             aline = linein(CONFIGDAS_SMP)
             i = length(aline)
             if i = 0 then
             do
               ret1 = 0
               ret = 0
               i = lineout(CONFIGDAS_NEW, aline)
             end
             else
             do
               i = lineout(CONFIGDAS_NEW, aline)
             end
          end
       end
    end
    
    
    ret =1
    
    /*-------------------------------------------*/
    /* server statement from config.smp          */
    /*-------------------------------------------*/
    say "Server statement ..."
    
    do while ret = 1
       line = linein(CONFIGDAS_SMP)
       i = compare('server',line)
       if i >= 7 then
       do
          i = lineout(CONFIGDAS_NEW, line)
          line = linein(CONFIGDAS_SMP)
          i = lineout(CONFIGDAS_NEW, line)
          line = linein(CONFIGDAS_SMP)
          i = lineout(CONFIGDAS_NEW, line)
          line = linein(CONFIGDAS_SMP)
          i = lineout(CONFIGDAS_NEW, line)
          ret = 0
       end
    end
  i = lineout(CONFIGDAS_NEW)
  copy "config.new config"
  del "config.new"
  end
  else
  do
    say ""
    say "ERROR: DAS\ETC\CONFIG file not found. Conversion of CONFIG failed!"
  end
end
else
do
  say ""
  say "INFO: DAS\ETC directory not found. Conversion of CONFIG failed!"
end
say ""
return








/************************************+***************************************/
/*                           Function DASINSTALL                            */
/************************************+***************************************/
DasInstall:
File = "A:\"DASFILE
DiskName = "OS/2_DAS_SERVER_SOFTWARE"
call DiskRequest File DiskName

/*--------------------------------------------------------------------------*/
/* Create DAS Directories                                                   */
/*--------------------------------------------------------------------------*/
newdir = directory( "C:/" )
if newdir = "C:\" then
do
  rc = SysMkDir( "DAS" )
  if rc = 0 then
  do
    say "INFO: DAS directory successfully created."
  end
  else
  do
    say "INFO: DAS directory could not be created!"
  end
end

/*--------------------------------------------------------------------------*/
/* Install DAS files...                                                     */
/*--------------------------------------------------------------------------*/
newdir = directory( "C:/DAS" )
if newdir = "C:\DAS" then
do
  say "INFO: Copying DAS Server software from diskette..."
  copy "A:\unzip.exe c:\das"
  if rc = 0 then
  do
    copy "A:\"DASFILE "C:\DAS\"DASFILE
    if rc = 0 then
    do
      unzip "-o " DASFILE
      if rc = 0 then
      do
        copy "C:\DAS\ETC\config.smp C:\DAS\ETC\config"
        say "INFO: DAS server installation completed successfully."
      end
      else
      do
        say "ERROR: DAS server installation failed..."
        say "       DAS server software could not be unzipped."
        signal ENDE
      end
      /*del "unzip.exe"*/
    end
    else
    do
      say "ERROR: DAS server installation failed..."
      say "       DAS server software could not be copied from diskette."
      signal ENDE
    end
  end
  else
  do
    say "ERROR: DAS server update failed..."
    say "       DAS cannot be unzipped because A:\UNZIP.EXE was not found."
    signal NOUNZIP
  end
end
else
do
  say "ERROR: DAS Server Software installation to C:\DAS failed!"
  say "       DAS needs to be installed manually in C:\DAS directory."
  signal ENDE
end
say ""
return

/************************************+***************************************/
/*                           Function DASUPDATE                             */
/************************************+***************************************/
DasUpdate:
newdir = directory( "C:/das" )
if newdir = "C:\das" then
do
  File = "A:\"DASFILE
  DiskName = "OS/2_DAS_SERVER_SOFTWARE"
  call DiskRequest File DiskName
  say "INFO: Copying DAS Server software from diskette..."
  copy "A:\unzip.exe"
  if rc = 0 then
  do
    copy "A:\"DASFILE "C:\DAS\"DASFILE
    if rc = 0 then
    do
      unzip "-o "DASFILE
      if rc = 0 then
      do
        say "INFO: DAS server update completed succesfully."
      end
      else
      do
        say "ERROR: DAS server update failed..."
        say "       DAS server software could not be unzipped."
        signal ENDE
      end
      /*del "unzip.exe"*/
    end
    else
    do
      say "ERROR: DAS server update failed..."
      say "       DAS server software could not be copied from diskette."
      signal ENDE
    end
  end
  else
  do
    say "ERROR: DAS server update failed..."
    say "       DAS cannot be unzipped because A:\UNZIP.EXE was not found."
    signal NOUNZIP
  end
end
else
do
  say "ERROR: DAS server update failed..."
  say "       DAS directory was not found."
  signal ENDE
end
say ""
return

/************************************+***************************************/
/*                           Function DUALDAS                               */
/************************************+***************************************/

DUALDAS:
'@echo off'

say ""
say "If you want to use DUALDAS type 'y' for yes  otherwise 'n' for no:"
say ""
cpos = SysCurPos(22,68)
Option = translate(SysGetKey('NOECHO'))
say ""
say ""
if Option = 'y' | Option = 'Y' then
do
  call SetPartner
  /*newdir = directory( "" )*/
end
return

/************************************+***************************************/
/*                           Function SetPartner                            */
/************************************+***************************************/

SetPartner:

DASPARTNERSET = 0

/*--------------------------------------------------------------------------*/
/* Read hostname of DAS_PARTNER                                             */
/*--------------------------------------------------------------------------*/

say ""
say "Type the hostname of the partner-pc:"
say ""
cpos = SysCurPos(22,37)
parse pull Partner
say Partner
say ""
say ""

/*--------------------------------------------------------------------------*/
/* Read IP-Adress of DAS_PARTNER                                            */
/*--------------------------------------------------------------------------*/

say ""
say "Type the IP-address of the partner-pc:"
say ""
cpos = SysCurPos(22,38)
parse pull IPAdress
say IPAdress
say ""
say ""

/*--------------------------------------------------------------------------*/
/* Look for DAS_PARTNER in the config.sys                                   */
/*--------------------------------------------------------------------------*/

say " "
say "############################################ "
say "INFO: Checking config.sys for DAS_PARTNER..."
say "############################################ "
say " "


ret = 1
do while ret = 1
  aline = linein(CONFIG_SYS)
  i = compare('SET DAS_PARTNER',aline)
  if i >= 16 then
  do
    ret = 0
    DASPARTNERSET = 1
    say "INFO: DAS_PARTNER already exists in the config.sys."
  end
  else
  do
    ret = lines(CONFIG_SYS)
  end
end

i = lineout(CONFIG_SYS)

/*--------------------------------------------------------------------------*/
/* Set DAS_PARTNER in the config.sys                                        */
/*--------------------------------------------------------------------------*/

DASPARTNERLINE = "SET DAS_PARTNER="Partner

ret = 1

if DASPARTNERSET = 0 then
do
  say " "
  say "########################################## "
  say "INFO: Set DAS_PARTNER in the config.sys..."
  say "########################################## "
  say " "
  attrib "-r c:\config.sys"
  copy "c:\config.sys c:\config.hosts"
  do while ret = 1
    aline = linein(CONFIG_SYS)
    ret = lines(CONFIG_SYS)
    if ret = 0 then
    do
      i = lineout(CONFIG_SYS, DASPARTNERLINE)
      say "INFO: DAS PARTNER PATH added."
    end
  end
end
i = lineout(CONFIG_SYS)


attrib "+r c:\config.sys"


/*--------------------------------------------------------------------------*/
/* Look for DAS_PARTNER in the hosts-file                                   */
/*--------------------------------------------------------------------------*/

env = 'OS2ENVIRONMENT'
pathhost = value(etc, ,env)
say pathhost


HOSTS_NEW=pathhost"\hosts.new"
HOSTS=pathhost"\hosts"

DASPARTNERHOSTSLINE = IPAdress"     "Partner

DASPARTNERSET = 0

newdir = directory( pathhost )
if newdir = pathhost then
do
  say " "
  say "############################################ "
  say "INFO: Checking host-file for partner host..."
  say "############################################ "
  say " "
  copy HOSTS pathhost"\hosts.das"
  if rc = 0 then
  do

    ret = 1
    do while ret = 1
      DONEALINE = 0
      aline = linein(HOSTS)
    
    
      if DONEALINE = 0 then
      do
          i = word(aline,2)
          i = compare(partner,i)
          if i = 0 then
          do
            DASPARTNERSET = 1
            say "INFO: DAS PARTNER already exists in the hosts-file."
          end
          i = word(aline,1)
          i = compare(IPAdress,i)
          if i = 0 then
          do
            DASPARTNERSET = 1
            say "INFO: IP-Adress already exists in the hosts-file."
          end
      end
      ret = lines(HOSTS)
    end
    i = lineout(hosts)
  end
  else
  do
    say ""
    say "hosts-file file not found. Create host file!"

    /*i = linein(HOSTS_NEW, 1, 0)*/

    if DASPARTNERSET = 0 then
    do
      i = lineout(HOSTS, DASPARTNERHOSTSLINE)
      say "INFO: DAS Partner was added in the host-file."
      return
    end

  end
end
else
do
  say ""
  say "INFO: "pathhost" directory not found!"
  return
end
say ""


/*--------------------------------------------------------------------------*/
/* Set of DAS_PARTNER in the hosts-file                                     */
/*--------------------------------------------------------------------------*/

ret = 1
if DASPARTNERSET = 0 then
do
  say " "
  say "############################################ "
  say "INFO: Set partner host in the host-file..."
  say "############################################ "
  say " "
  do while ret = 1
    aline = linein(HOSTS)
    ret = lines(HOSTS)
    if ret = 0 then
    do
      i = lineout(HOSTS, DASPARTNERHOSTSLINE)
      say "INFO: DAS Partner was added in the host-file."
    end
  end
end

i = lineout(HOSTS)

attrib "-r "HOSTS



return

/************************************+***************************************/
/*                           Function Deinst_of_Update                      */
/************************************+***************************************/

Deinst_of_Update:


newdir = directory( "C:\das" )
if newdir = "C:\das" then
do
  say ""
  say "Deinstall DAS-Update --> Are you sure [Y/N]:"
  say ""
  cpos = SysCurPos(3,40)
  Option = translate(SysGetKey('NOECHO'))
  say ""
  say ""
  if Option = 'y' | Option = 'Y' then
  do
    say "INFO: Deinstall of the last DAS-Update..."
    say ""
    say ""
    copy BACKUP_DIR"\*.* ."
    xcopy BACKUP_BIN ".\bin" "/s"
    xcopy BACKUP_ETC ".\etc" "/s"
    xcopy BACKUP_TOOLS ".\tools" "/s"
    attrib "-r" BACKUP_DIR"\*.* /s"
    del BACKUP_DIR"\*.* /N"
    del BACKUP_BIN"\*.* /N"
    del BACKUP_ETC"\*.* /N"
    del BACKUP_TOOLS"\*.* /N"
    del BACKUP_TOOLS"\db2\*.* /N"
    del BACKUP_TOOLS"\dbm\*.* /N"
    del BACKUP_ACI"\*.* /N"
    rd  BACKUP_BIN
    rd  BACKUP_ETC
    rd  BACKUP_TOOLS"\db2"
    rd  BACKUP_TOOLS"\dbm"
    rd  BACKUP_TOOLS
    rd  BACKUP_ACI
    rd  BACKUP_DIR
    /*
    rc = SysRmDir("c:\das\das_save")
    say rc
    */
    say ""
    say "INFO: DAS update was successfully deinstalled."
    say ""
    call beep note.1,viertel
    call beep note.5,viertel
    call SysSleep 3
  end
  else
  do
    return
  end
end
else
do
  say ""
  say "ERROR: Unable to change to DAS directory."
  say ""
  SIGNAL ENDE2
end
return

/************************************+***************************************/
/*                           Function aci_install                           */
/************************************+***************************************/
aci_install:

do
  say ""
  say "Would you like to copy the ACI libraries? (Y/N) <CR>"
  Answer = translate(SysGetKey('ECHO'))

  if Answer = 'y' | Answer = 'Y' then
  do
    /*----------------------------------------------------------------------*/
    /* Create ACI Directory                                                 */
    /*----------------------------------------------------------------------*/
    newdir = directory( "C:/DAS" )
    if newdir = "C:\DAS" then
    do
      rc = SysMkDir( "ACI" )
      if rc = 0 then
      do
        say "INFO: ACI directory successfully created."
      end
      else
      do
        say "INFO: ACI directory could not be created!"
      end
    end

    /*----------------------------------------------------------------------*/
    /* Change to ACI directory                                              */
    /*----------------------------------------------------------------------*/
    newdir = directory( "C:/DAS/ACI" )
    if newdir = "C:\DAS\ACI" then
    do
      DiskName = "AML_CLIENT_INTERFACE_(ACI)_DISK_2_OF_3"
      File1 = ACIFILE1
      say ""
      do ACIDISKS
        call DiskRequest "A:\"File1 DiskName
        say "INFO: Copying ACI Client software from diskette..."
        say ""
        copy "a:\"File1 "C:\DAS\ACI"
        if rc = 0 then
        do
          "C:\DAS\"unzip "-o " File1
          if rc = 0 then
          do
            del File1
          end
          else
          do
            say "ERROR: ACI client installation failed..."
            say "       ACI client software could not be unzipped."
            signal ENDE
          end
        end
        else
        do
          say "ERROR: ACI client installation failed..."
          say "       ACI client software could not be copied from diskette."
          signal ENDE
        end
        DiskName = "AML_CLIENT_INTERFACE_(ACI)_DISK_3_OF_3"
        File1 = ACIFILE2
      end

      say "INFO: ACI client components installed successfully."
      del "C:\DAS\unzip.exe"
    end
    else
    do
      say "ERROR: ACI client software installation to C:\DAS\ACI failed!"
      say "       ACI needs to be installed manually in C:\DAS\ACI directory."
      signal ENDE
    end
  end
  say ""
end
return


/************************************+***************************************/
/*                           Function Deinst_of_DAS                         */
/************************************+***************************************/

Deinst_of_DAS:


say ""
say "Deinstall DAS --> Are you sure [Y/N]:"
say ""
cpos = SysCurPos(3,40)
Option = translate(SysGetKey('NOECHO'))
say ""
say ""
if Option = 'y' | Option = 'Y' then
do
  say "INFO: Deinstall of DAS..."
  say ""
  say ""
  attrib "-r" DAS_DIR"\*.* /s"
  del BACKUP_DIR"\*.* /N"
  del BACKUP_BIN"\*.* /N"
  del BACKUP_ETC"\*.* /N"
  del BACKUP_TOOLS"\*.* /N"
  del BACKUP_TOOLS"\db2\*.* /N"
  del BACKUP_TOOLS"\dbm\*.* /N"
  del BACKUP_ACI"\*.* /N"
  rd  BACKUP_BIN
  rd  BACKUP_ETC
  rd  BACKUP_TOOLS"\db2"
  rd  BACKUP_TOOLS"\dbm"
  rd  BACKUP_TOOLS
  rd  BACKUP_ACI
  rd  BACKUP_DIR

  del DAS_DIR"\*.* /N"
  del DAS_BIN"\*.* /N"
  del DAS_ETC"\*.* /N"
  del DAS_TOOLS"\*.* /N"
  del DAS_TOOLS"\db2\*.* /N"
  del DAS_TOOLS"\dbm\*.* /N"
  del DAS_ACI"\*.* /N"
  rd  DAS_BIN
  rd  DAS_ETC
  rd  DAS_TOOLS"\db2"
  rd  DAS_TOOLS"\dbm"
  rd  DAS_TOOLS
  rd  DAS_ACI
  rd  DAS_DIR


  say ""
  say "INFO: DAS was successfully deinstalled."
  say ""
  call beep note.1,viertel
  call beep note.5,viertel
  call SysSleep 3
end

return

/************************************+***************************************/
/*                           Function DISKREQUEST                           */
/************************************+***************************************/
DiskRequest:
parse arg File Diskname
say ""
DiskIsCorrect = 0
do until DiskIsCorrect = 1
  say 'INFO: Searching for file ' File
  call SysFileTree file, 'datei', 'F'
  if datei.0 = 0 then
  do
    say ""
    say "INFO: DAS software file was not found!"
    call beep note.1,250
    say 'Insert 'Diskname', DISK 1 of 1, into drive A:'
    say "Press <CR> when ready..."
    pull answer
    DiskIsCorrect = 0
  end
  else
  do
    DiskIsCorrect = 1
    say "INFO: DAS software file was found."
  end
end
return

/************************************+***************************************/
/*                           Function ANSWERYN                              */
/************************************+***************************************/
AnswerYN:
parse arg question
call beep note.1,250
say ""
say question
AnswerIsYN = 0
do while AnswerIsYN = 0
  parse upper pull answer
  if answer = 'Y' | answer = 'N' then
  do
    AnswerIsYN = 1
  end
  else
  do
    call beep note.1,250
    say "Please enter only Y or N then <CR>..."
    say""
  end
end
return answer


/************************************+***************************************/
/*                           Function GOODEND                               */
/************************************+***************************************/
GOODEND:
cls
say ""
say "               END OF SUCCESSFUL DAS-SOFTWARE INSTALLATION"
say "                          !CONGRATULATIONS!"
say ""
/*
call beep note.1,viertel
call beep note.5,viertel
call beep note.5,viertel
call beep note.4,achtel
call beep note.3,achtel
call beep note.4,achtel
call beep note.3,achtel
call beep note.2,viertel
call beep note.2,viertel
call beep note.1,achtel
call beep note.2,achtel
call beep note.3,viertel
call beep note.2,achtel
call beep note.3,achtel
call beep note.4,viertel
call beep note.3,achtel
call beep note.1,achtel
call beep note.3,achtelpkt
call beep note.2,sechzehntel
call beep note.2,viertel
*/
cls
say "   Add the following statements to the end of your startup.cmd file to"
say "   automatically start the AMU AMS and DAS server software:"
say ""
type STARTUP_SAMPLE
say ""
say "Continue with enter:"
say ""
cpos = SysCurPos(19,27)
Option = translate(SysGetKey('NOECHO'))
cls
say ""
say ""
say "   Make sure the DAS server software is configured correctly."
say ""
say "   - Check your CONFIG.SYS"
say "   - define the hostname and IP-adress in the host-file for the clieet-mashines"
say "   - configure the statements in the file c:\das\etc\config"
say ""
say "   Assure that TCP/IP is configured correctly and the portmapper started!"
say ""
say ""
say "Continue with enter:"
say ""
cpos = SysCurPos(11,27)
Option = translate(SysGetKey('NOECHO'))
cls
say ""
say ""
say ""
say "   Information for the configuration"
say "   #################################"
say ""
say "   If you can't reboot, continue with the following steps:"
say ""
say "   - set the variable DAS_SERVER and DAS_CLIENT in the DAS-Window"
say "     to use dasadmin on OS/2"
say "     ---> see DAS-Administration Guide"
say ""
say "   - For DUALDAS:"
say "     - set DAS_PARTNER in the DAS-Window"
say "     ---> see DAS-Administration Guide"

say ""
say "Continue with enter:"
say ""
cpos = SysCurPos(16,27)
Option = translate(SysGetKey('NOECHO'))

newdir = directory( "C:\" )
EXIT


/************************************+***************************************/
/*                           Function NOUNZIP                               */
/************************************+***************************************/
NOUNZIP:
say ""
say "ERROR: UNZIP.EXE not found!"
say "       Obtain a copy of UNZIP.EXE, copy it to the DAS diskette"
say "       and retry the DAS installation."
say ""
SIGNAL ENDE


/************************************+***************************************/
/*                           Function ENDE                                  */
/************************************+***************************************/
ENDE:
call beep note.1,250
say ""
say ""
say "                     A severe error occurred..."
say ""
say "          DAS installation did not complete successfully!"
say "      Contact your DAS support representative for assistance."
say ""
newdir = directory( "C:\" )
EXIT

/************************************+***************************************/
/*                           Function ENDE2                                 */
/************************************+***************************************/
ENDE2:
call beep note.1,250
say ""
say ""
say "                     A severe error occurred..."
say ""
say "          DAS Deinstallation did not complete successfully!"
say "      Contact your DAS support representative for assistance."
say ""
newdir = directory( "C:\" )
EXIT

